/* <begin connected objects> */
/*
This file is auto generated by pgrx.

The ordering of items is not stable, it is driven by a dependency graph.
*/
/* </end connected objects> */

/* <begin connected objects> */
-- src/lib.rs:25
-- bootstrap
-- create roles for parquet object store read and write if they do not exist
DO $$
BEGIN
    IF NOT EXISTS (SELECT 1 FROM pg_roles WHERE rolname = 'parquet_object_store_read') THEN
        CREATE ROLE parquet_object_store_read;
    END IF;
    IF NOT EXISTS (SELECT 1 FROM pg_roles WHERE rolname = 'parquet_object_store_write') THEN
        CREATE ROLE parquet_object_store_write;
    END IF;
END $$;

-- error if the schema already exists
CREATE SCHEMA parquet;
REVOKE ALL ON SCHEMA parquet FROM public;
GRANT USAGE ON SCHEMA parquet TO public;
GRANT EXECUTE ON ALL FUNCTIONS IN SCHEMA parquet TO public;
/* </end connected objects> */

/* <begin connected objects> */
-- src/parquet_udfs/schema.rs:11
CREATE SCHEMA IF NOT EXISTS parquet; /* pg_parquet::parquet_udfs::schema::parquet */
/* </end connected objects> */

/* <begin connected objects> */
-- src/parquet_udfs/schema.rs:15
-- pg_parquet::parquet_udfs::schema::parquet::schema
CREATE  FUNCTION parquet."schema"(
	"uri" TEXT /* alloc::string::String */
) RETURNS TABLE (
	"uri" TEXT,  /* alloc::string::String */
	"name" TEXT,  /* alloc::string::String */
	"type_name" TEXT,  /* core::option::Option<alloc::string::String> */
	"type_length" TEXT,  /* core::option::Option<alloc::string::String> */
	"repetition_type" TEXT,  /* core::option::Option<alloc::string::String> */
	"num_children" INT,  /* core::option::Option<i32> */
	"converted_type" TEXT,  /* core::option::Option<alloc::string::String> */
	"scale" INT,  /* core::option::Option<i32> */
	"precision" INT,  /* core::option::Option<i32> */
	"field_id" INT,  /* core::option::Option<i32> */
	"logical_type" TEXT  /* core::option::Option<alloc::string::String> */
)
STRICT
LANGUAGE c /* Rust */
AS 'MODULE_PATHNAME', 'schema_wrapper';
/* </end connected objects> */

/* <begin connected objects> */
-- src/parquet_udfs/metadata.rs:8
CREATE SCHEMA IF NOT EXISTS parquet; /* pg_parquet::parquet_udfs::metadata::parquet */
/* </end connected objects> */

/* <begin connected objects> */
-- src/parquet_udfs/metadata.rs:12
-- pg_parquet::parquet_udfs::metadata::parquet::metadata
CREATE  FUNCTION parquet."metadata"(
	"uri" TEXT /* alloc::string::String */
) RETURNS TABLE (
	"uri" TEXT,  /* alloc::string::String */
	"row_group_id" bigint,  /* i64 */
	"row_group_num_rows" bigint,  /* i64 */
	"row_group_num_columns" bigint,  /* i64 */
	"row_group_bytes" bigint,  /* i64 */
	"column_id" bigint,  /* i64 */
	"file_offset" bigint,  /* i64 */
	"num_values" bigint,  /* i64 */
	"path_in_schema" TEXT,  /* alloc::string::String */
	"type_name" TEXT,  /* alloc::string::String */
	"stats_null_count" bigint,  /* core::option::Option<i64> */
	"stats_distinct_count" bigint,  /* core::option::Option<i64> */
	"stats_min" TEXT,  /* core::option::Option<alloc::string::String> */
	"stats_max" TEXT,  /* core::option::Option<alloc::string::String> */
	"compression" TEXT,  /* alloc::string::String */
	"encodings" TEXT,  /* alloc::string::String */
	"index_page_offset" bigint,  /* core::option::Option<i64> */
	"dictionary_page_offset" bigint,  /* core::option::Option<i64> */
	"data_page_offset" bigint,  /* i64 */
	"total_compressed_size" bigint,  /* i64 */
	"total_uncompressed_size" bigint  /* i64 */
)
STRICT
LANGUAGE c /* Rust */
AS 'MODULE_PATHNAME', 'metadata_wrapper';
/* </end connected objects> */

/* <begin connected objects> */
-- src/parquet_udfs/metadata.rs:176
-- pg_parquet::parquet_udfs::metadata::parquet::kv_metadata
CREATE  FUNCTION parquet."kv_metadata"(
	"uri" TEXT /* alloc::string::String */
) RETURNS TABLE (
	"uri" TEXT,  /* alloc::string::String */
	"key" bytea,  /* alloc::vec::Vec<u8> */
	"value" bytea  /* core::option::Option<alloc::vec::Vec<u8>> */
)
STRICT
LANGUAGE c /* Rust */
AS 'MODULE_PATHNAME', 'kv_metadata_wrapper';
/* </end connected objects> */

/* <begin connected objects> */
-- src/parquet_udfs/metadata.rs:132
-- pg_parquet::parquet_udfs::metadata::parquet::file_metadata
CREATE  FUNCTION parquet."file_metadata"(
	"uri" TEXT /* alloc::string::String */
) RETURNS TABLE (
	"uri" TEXT,  /* alloc::string::String */
	"created_by" TEXT,  /* core::option::Option<alloc::string::String> */
	"num_rows" bigint,  /* i64 */
	"num_row_groups" bigint,  /* i64 */
	"format_version" TEXT  /* alloc::string::String */
)
STRICT
LANGUAGE c /* Rust */
AS 'MODULE_PATHNAME', 'file_metadata_wrapper';
/* </end connected objects> */

